
USE [master] 
GO 
CREATE DATABASE PITRTest ON ( NAME = 'PITRTest' , FILENAME = 'C:\temp\PITRTest.mdf' ) 
log ON ( NAME = 'PITRTest_log' , FILENAME = 'C:\temp\PITRTest_log.ldf' ) 
GO 
USE PITRTest 
GO 
----============== Setting the recovery model for database as FULL
ALTER DATABASE PITRTest SET RECOVERY FULL 
GO 
IF object_id ( 'Example' ) IS NOT NULL 
BEGIN 
    DROP TABLE Example 
END 
GO 
----============== Creating a test table with some data for our demo
CREATE TABLE Example 
( 
    ID int IDENTITY ( 1 , 1 ) , Data varchar ( 1 ) 
) 
GO 
INSERT INTO Example 
( Data ) 
VALUES ( 'A' ) , 
( 'B' ) , 
( 'C' ) , 
( 'D' ) , 
( 'E' ) 

----============== Taking a Full database backup
BACKUP DATABASE PITRTest TO DISK = 'C:\temp\PITRTest_FULL_1.BAK' 
WITH STATS = 1 , INIT 
-- After the FULL BACKUP IS done , we INSERT few more rows INTO our test TABLE AND take the first T - log backup. 
INSERT INTO Example 
VALUES ( 'F' ) , 
( 'G' ) , 
( 'H' ) , 
( 'I' ) , 
( 'J' ) 
GO 
BACKUP log PITRTest TO DISK = 'C:\temp\PITRTest_Log_1.trn' 
WITH STATS = 1 , INIT 
GO 

INSERT INTO Example VALUES ( 'K' ) , ( 'L' ) , ( 'M' ) , ( 'N' ) , ( 'O' ) , ( 'P' ) , ( 'Q' ) , ( 'R' ) , ( 'S' ) , ( 'T' ) 
GO 
--=============== Printing the time before performing the truncate
SELECT getdate ( ) AS TimeBeforeTruncate ---> 2014-04-18 02:20:37.277

GO 
-- =============== Truncating the table

USE [master]
GO
ALTER DATABASE [PITRTest] SET RECOVERY BULK_LOGGED WITH NO_WAIT
GO
 
USE [PITRTest]
GO

SET ANSI_PADDING ON
GO

CREATE CLUSTERED INDEX [ClusteredIndex-20150304-182330] ON [dbo].[Example]
(
	[ID] ASC,
	[Data] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)

GO

ALTER INDEX [ClusteredIndex-20150304-182330] ON [dbo].[Example] REBUILD;

BACKUP log PITRTest TO DISK = 'C:\temp\PITRTest_Log_2.trn' 
WITH STATS = 1 , INIT 
GO 

ALTER DATABASE PITRTest SET RECOVERY FULL 
GO 

BACKUP log PITRTest TO DISK = 'C:\temp\PITRTest_Log_3.trn' 
WITH STATS = 1 , INIT 
GO 

TRUNCATE TABLE Example 
GO 
-- 2015/03/04 18:29:41:913

SELECT 
[Transaction Name] , 
suser_sname ( [Transaction SID] ) AS UserName , 
[Begin Time] , 
Operation , 
[Transaction ID] 
FROM fn_dblog ( NULL , NULL ) 
WHERE /* [Transaction ID] = @TransactionID -- Transaction ID
AND */ [Transaction Name] LIKE 'TRUNCATE%' 
AND Operation = 'LOP_BEGIN_XACT'

BACKUP log PITRTest TO DISK = 'C:\temp\PITRTest_Log_4.trn' WITH STATS = 1 , INIT 
GO

--  "" 
USE MASTER
GO
BACKUP LOG PITRTest TO DISK = 'C:\temp\PITRTest_Log_Tail.trn' WITH NORECOVERY
GO
--===============    
USE MASTER
GO
RESTORE DATABASE PITRTest FROM DISK = 'C:\temp\PITRTest_FULL_1.BAK' 
WITH STATS = 1 , NORECOVERY , 
MOVE 'PITRTest' TO 'C:\temp\PITRTest_2.mdf' , 
MOVE 'PITRTest_log' TO 'C:\temp\PITRTest_2_log.ldf' 

RESTORE log PITRTest FROM DISK = 'C:\temp\PITRTest_Log_1.trn' 
WITH STATS = 1 , NORECOVERY 
GO 
RESTORE log PITRTest FROM DISK = 'C:\temp\PITRTest_Log_2.trn' 
WITH STATS = 1 , NORECOVERY 
GO 
RESTORE log PITRTest FROM DISK = 'C:\temp\PITRTest_Log_3.trn' 
WITH STATS = 1 , NORECOVERY 
GO 
RESTORE log PITRTest FROM DISK = 'C:\temp\PITRTest_Log_4.trn' 
WITH STATS = 1 , STANDBY = 'C:\temp\PITRTestStandBy.tuf', STOPAT = '2015/03/04 19:33:49:500' 
GO
RESTORE log PITRTest FROM DISK = 'C:\temp\PITRTest_Log_4.trn' 
WITH STATS = 1 , STANDBY = 'C:\temp\PITRTestStandBy.tuf', STOPAT = '2015/03/04 19:33:50:003' 
GO
RESTORE log PITRTest FROM DISK = 'C:\temp\PITRTest_Log_4.trn' 
WITH STATS = 1 , RECOVERY , STOPAT = '2015/03/04 19:33:50:072' 
--    .      

SELECT * FROM PITRTest..Example -->    


/*
   
   64   ,       
SELECT [Transaction Name] , suser_sname ( [Transaction SID] ) AS UserName , [Begin Time] , Operation , [Transaction ID]  
FROM sys.fn_dump_dblog 
(DEFAULT, DEFAULT, DEFAULT, DEFAULT, 'C:\temp\PITRTest_Log_4.trn',
NULL,NULL,NULL,NULL,NULL,NULL,NULL,
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL)
WHERE [Transaction Name] LIKE 'TRUNCATE%' 
AND Operation = 'LOP_BEGIN_XACT'
*/